#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <sys/time.h>

using namespace std;

#include "tree.h"

int        main();

int main()
{
        avl_t<int>                       tree;

/*
  cerr << "inserting: " << setw(2) <<  7 << " ";  tree.insert(7);  cerr << endl;
  cerr << "inserting: " << setw(2) <<  4 << " ";  tree.insert(4);  cerr << endl;
  cerr << "inserting: " << setw(2) <<  9 << " ";  tree.insert(9);  cerr << endl;
  cerr << "inserting: " << setw(2) << 16 << " "; tree.insert(16);  cerr << endl;
  cerr << "inserting: " << setw(2) <<  3 << " ";  tree.insert(3);  cerr << endl;
  cerr << "inserting: " << setw(2) <<  5 << " ";  tree.insert(5);  cerr << endl;
  cerr << "inserting: " << setw(2) <<  2 << " ";  tree.insert(2);  cerr << endl;
  cerr << "inserting: " << setw(2) <<  1 << " ";  tree.insert(1);  cerr << endl;
  cout << "AVL tree:: " << endl << tree;

  return 0;
*/

  // single rotations
  cerr << "inserting: " << setw(2) <<  6 << " ";  tree.insert(6);  cerr << endl;
  cerr << "inserting: " << setw(2) <<  4 << " ";  tree.insert(4);  cerr << endl;
  cerr << "inserting: " << setw(2) <<  2 << " ";  tree.insert(2);  cerr << endl;
  cerr << "inserting: " << setw(2) <<  8 << " ";  tree.insert(8);  cerr << endl;
  cerr << "inserting: " << setw(2) << 10 << " "; tree.insert(10);  cerr << endl;
  cerr << "inserting: " << setw(2) << 12 << " "; tree.insert(12);  cerr << endl;
  cerr << "inserting: " << setw(2) << 14 << " "; tree.insert(14);  cerr << endl;

  // double rotations
  cerr << "inserting: " << setw(2) << 32 << " "; tree.insert(32);  cerr << endl;
  cerr << "inserting: " << setw(2) << 30 << " "; tree.insert(30);  cerr << endl;
  cerr << "inserting: " << setw(2) << 28 << " "; tree.insert(28);  cerr << endl;

  // set up for deletion
  cerr << "inserting: " << setw(2) <<  3 << " ";  tree.insert(3);  cerr << endl;
  cerr << "inserting: " << setw(2) << 31 << " "; tree.insert(31);  cerr << endl;

  // inorder tree traversal
  cout << "AVL tree: " << endl << tree;

  // erase
  cerr << "  erasing: " << setw(2) <<  6 << " ";   tree.erase(6);  cerr << endl;

  // inorder tree traversal
  cout << "AVL tree: " << endl << tree;
}
